您的位置:首页 > 其它

HDU 2845 Beans(最大不连续子序列和 dp)

2017-03-03 14:23 435 查看

                                                   Beans

[align=left]Problem Description[/align]
Bean-eating is an interesting game, everyone owns an M*N matrix, which is filled with different qualities beans. Meantime, there is only one bean in any 1*1 grid. Now you want to eat the beans and collect the qualities, but everyone
must obey by the following rules: if you eat the bean at the coordinate(x, y), you can’t eat the beans anyway at the coordinates listed (if exiting): (x, y-1), (x, y+1), and the both rows whose abscissas are x-1 and x+1.



Now, how much qualities can you eat and then get ?
 

[align=left]Input[/align]
There are a few cases. In each case, there are two integer M (row number) and N (column number). The next M lines each contain N integers, representing the qualities of the beans. We can make sure that the quality of bean isn't beyond
1000, and 1<=M*N<=200000.
 

[align=left]Output[/align]
For each case, you just output the MAX qualities you can eat and then get.
 

[align=left]Sample Input[/align]

4 6
11 0 7 5 13 9
78 4 81 6 22 4
1 40 9 34 16 10
11 22 0 33 39 6

 

[align=left]Sample Output[/align]

242

题意:如图中数字81,如果81取了,那么它上面、下面的行就不能取了,左右的也不能取了。

思路:两次dp,一次行,一次列,状态方程相同dp(i)=max(dp(i-1),dp(i-2)+tmp);

AC代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int maxn=2e5+10;
int dpx[maxn],dpy[maxn];
int main(){
int n,m;
while(scanf("%d%d",&m,&n)==2){

memset(dpy,0,sizeof(dpy));
for(int i=m;i>=1;i--)
{
for(int j=1;j<=n;j++)
{int tmp;
scanf("%d",&tmp);
int t=j+2; //因为j-2可能小于0所以整体向后移2
dpy[t]=max(dpy[t-1],dpy[t-2]+tmp);
}
dpx[i]=dpy[n+2];
}

if(dpx[2]<dpx[1])dpx[2]=dpx[1];
for(int i=3;i<=m;i++)
dpx[i]=max(dpx[i-1],dpx[i-2]+dpx[i]);

printf("%d\n",dpx[m]);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: